Botan: Botan::Noekeon_SIMD Class Reference

Botan 1.10.16

Public Types | Public Member Functions | Protected Member Functions | Static Protected Attributes | List of all members
Botan::Noekeon_SIMD Class Reference

`#include <noekeon_simd.h>`

Inheritance diagram for Botan::Noekeon_SIMD:

## Public Types
enum |

## Public Member Functions
size_t | block_size () const
void | clear ()
BlockCipher * | clone () const
void | decrypt (const byte in[], byte out[]) const
void | decrypt (byte block[]) const
void | decrypt_n (const byte in[], byte out[], size_t blocks) const
void | encrypt (const byte in[], byte out[]) const
void | encrypt (byte block[]) const
void | encrypt_n (const byte in[], byte out[], size_t blocks) const
Key_Length_Specification | key_spec () const
size_t | maximum_keylength () const
size_t | minimum_keylength () const
std::string | name () const
size_t | parallel_bytes () const
size_t | parallelism () const
void | set_key (const SymmetricKey &key)
void | set_key (const byte key[], size_t length)
bool | valid_keylength (size_t length) const

## Protected Member Functions
const SecureVector< u32bit > & | get_DK () const
const SecureVector< u32bit > & | get_EK () const

## Static Protected Attributes
static const byte | RC [17]

## Detailed Description

Noekeon implementation using SIMD operations

Definition at line 18 of file noekeon_simd.h.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum
| inherited

Definition at line 107 of file block_cipher.h.

107 { BLOCK_SIZE = BS };
Botan::Block_Cipher_Fixed_Params< 16, 16 >::BLOCK_SIZE
Definition: block_cipher.h:107

## Member Function Documentation

## ◆ block_size()

size_t Botan::Block_Cipher_Fixed_Params< BS, KMIN, 0 , 1 >::block_size | ( |  | ) | const
| inlinevirtualinherited

Returns
  block size of this algorithm

Implements Botan::BlockCipher.

Definition at line 108 of file block_cipher.h.

108 { return BS; }

## ◆ clear()

void Botan::Noekeon::clear | ( |  | ) |
| virtualinherited

Zeroize internal state

Implements Botan::Algorithm.

Definition at line 204 of file noekeon.cpp.

References Botan::zeroise().

205 {
206 zeroise(EK);
207 zeroise(DK);
208 }
Botan::zeroise
void zeroise(MemoryRegion< T > &vec)
Definition: secmem.h:415

## ◆ clone()

BlockCipher* Botan::Noekeon_SIMD::clone | ( |  | ) | const
| inlinevirtual

Get a new object representing the same algorithm as *this

Reimplemented from Botan::Noekeon.

Definition at line 26 of file noekeon_simd.h.

26 { return new Noekeon_SIMD; }

## ◆ decrypt() [1/2]

void Botan::BlockCipher::decrypt | ( | const byte | in[],
|  | byte | out[]
| ) |  | const
| inlineinherited

Decrypt a block.

Parameters

  in | The ciphertext block to be decypted as a byte array. Must be of length block_size().
  out | The byte array designated to hold the decrypted block. Must be of length block_size().

Definition at line 57 of file block_cipher.h.

Referenced by Botan::DESX::decrypt_n(), Botan::ECB_Decryption::name(), Botan::CTS_Decryption::set_iv(), and Botan::CBC_Decryption::set_iv().

58 { decrypt_n(in, out, 1); }
Botan::BlockCipher::decrypt_n
virtual void decrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ decrypt() [2/2]

void Botan::BlockCipher::decrypt | ( | byte | block[] | ) | const
| inlineinherited

Decrypt a block.

Parameters

  block | the ciphertext block to be decrypted Must be of length block_size(). Will hold the result when the function has finished.

Definition at line 74 of file block_cipher.h.

74 { decrypt_n(block, block, 1); }
Botan::BlockCipher::decrypt_n
virtual void decrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ decrypt_n()

void Botan::Noekeon_SIMD::decrypt_n | ( | const byte | in[],
|  | byte | out[],
|  | size_t | blocks
| ) |  | const
| virtual

Decrypt one or more blocks

Parameters

  in | the input buffer (multiple of block_size())
  out | the output buffer (same size as in)
  blocks | the number of blocks to process

Reimplemented from Botan::Noekeon.

Definition at line 123 of file noekeon_simd.cpp.

References Botan::Noekeon::decrypt_n(), Botan::Noekeon::get_DK(), Botan::load_be(), NOK_SIMD_GAMMA, NOK_SIMD_THETA, and Botan::Noekeon::RC.

124 {
125 const SecureVector<u32bit>& DK = this->get_DK();
126
127 SIMD_32 K0 = SIMD_32(DK[0]);
128 SIMD_32 K1 = SIMD_32(DK[1]);
129 SIMD_32 K2 = SIMD_32(DK[2]);
130 SIMD_32 K3 = SIMD_32(DK[3]);
131
132 while(blocks >= 4)
133 {
134 SIMD_32 A0 = SIMD_32::load_be(in );
135 SIMD_32 A1 = SIMD_32::load_be(in + 16);
136 SIMD_32 A2 = SIMD_32::load_be(in + 32);
137 SIMD_32 A3 = SIMD_32::load_be(in + 48);
138
139 SIMD_32::transpose(A0, A1, A2, A3);
140
141 for(size_t i = 0; i != 16; ++i)
142 {
143 NOK_SIMD_THETA(A0, A1, A2, A3, K0, K1, K2, K3);
144
145 A0 ^= SIMD_32(RC[16-i]);
146
147 A1.rotate_left(1);
148 A2.rotate_left(5);
149 A3.rotate_left(2);
150
151 NOK_SIMD_GAMMA(A0, A1, A2, A3);
152
153 A1.rotate_right(1);
154 A2.rotate_right(5);
155 A3.rotate_right(2);
156 }
157
158 NOK_SIMD_THETA(A0, A1, A2, A3, K0, K1, K2, K3);
159 A0 ^= SIMD_32(RC[0]);
160
161 SIMD_32::transpose(A0, A1, A2, A3);
162
163 A0.store_be(out);
164 A1.store_be(out + 16);
165 A2.store_be(out + 32);
166 A3.store_be(out + 48);
167
168 in += 64;
169 out += 64;
170 blocks -= 4;
171 }
172
173 if(blocks)
174 Noekeon::decrypt_n(in, out, blocks);
175 }
Botan::load_be
T load_be(const byte in[], size_t off)
Definition: loadstor.h:100
NOK_SIMD_GAMMA
#define NOK_SIMD_GAMMA(A0, A1, A2, A3)
Definition: noekeon_simd.cpp:47
Botan::Noekeon::RC
static const byte RC[17]
Definition: noekeon.h:33
NOK_SIMD_THETA
#define NOK_SIMD_THETA(A0, A1, A2, A3, K0, K1, K2, K3)
Definition: noekeon_simd.cpp:16
Botan::Noekeon::decrypt_n
void decrypt_n(const byte in[], byte out[], size_t blocks) const
Definition: noekeon.cpp:125
Botan::Noekeon::get_DK
const SecureVector< u32bit > & get_DK() const
Definition: noekeon.h:43

## ◆ encrypt() [1/2]

void Botan::BlockCipher::encrypt | ( | const byte | in[],
|  | byte | out[]
| ) |  | const
| inlineinherited

Encrypt a block.

Parameters

  in | The plaintext block to be encrypted as a byte array. Must be of length block_size().
  out | The byte array designated to hold the encrypted block. Must be of length block_size().

Definition at line 47 of file block_cipher.h.

Referenced by Botan::aont_unpackage(), Botan::OFB::cipher(), Botan::DESX::encrypt_n(), Botan::CMAC::poly_double(), Botan::ANSI_X931_RNG::randomize(), Botan::Randpool::randomize(), Botan::CTS_Encryption::set_iv(), Botan::CFB_Encryption::set_iv(), Botan::OFB::set_iv(), Botan::XTS_Encryption::set_iv(), Botan::CBC_Encryption::set_iv(), Botan::CFB_Decryption::set_iv(), and Botan::XTS_Decryption::set_iv().

48 { encrypt_n(in, out, 1); }
Botan::BlockCipher::encrypt_n
virtual void encrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ encrypt() [2/2]

void Botan::BlockCipher::encrypt | ( | byte | block[] | ) | const
| inlineinherited

Encrypt a block.

Parameters

  block | the plaintext block to be encrypted Must be of length block_size(). Will hold the result when the function has finished.

Definition at line 66 of file block_cipher.h.

66 { encrypt_n(block, block, 1); }
Botan::BlockCipher::encrypt_n
virtual void encrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ encrypt_n()

void Botan::Noekeon_SIMD::encrypt_n | ( | const byte | in[],
|  | byte | out[],
|  | size_t | blocks
| ) |  | const
| virtual

Encrypt one or more blocks

Parameters

  in | the input buffer (multiple of block_size())
  out | the output buffer (same size as in)
  blocks | the number of blocks to process

Reimplemented from Botan::Noekeon.

Definition at line 66 of file noekeon_simd.cpp.

References Botan::Noekeon::encrypt_n(), Botan::Noekeon::get_EK(), Botan::load_be(), NOK_SIMD_GAMMA, NOK_SIMD_THETA, and Botan::Noekeon::RC.

67 {
68 const SecureVector<u32bit>& EK = this->get_EK();
69
70 SIMD_32 K0 = SIMD_32(EK[0]);
71 SIMD_32 K1 = SIMD_32(EK[1]);
72 SIMD_32 K2 = SIMD_32(EK[2]);
73 SIMD_32 K3 = SIMD_32(EK[3]);
74
75 while(blocks >= 4)
76 {
77 SIMD_32 A0 = SIMD_32::load_be(in );
78 SIMD_32 A1 = SIMD_32::load_be(in + 16);
79 SIMD_32 A2 = SIMD_32::load_be(in + 32);
80 SIMD_32 A3 = SIMD_32::load_be(in + 48);
81
82 SIMD_32::transpose(A0, A1, A2, A3);
83
84 for(size_t i = 0; i != 16; ++i)
85 {
86 A0 ^= SIMD_32(RC[i]);
87
88 NOK_SIMD_THETA(A0, A1, A2, A3, K0, K1, K2, K3);
89
90 A1.rotate_left(1);
91 A2.rotate_left(5);
92 A3.rotate_left(2);
93
94 NOK_SIMD_GAMMA(A0, A1, A2, A3);
95
96 A1.rotate_right(1);
97 A2.rotate_right(5);
98 A3.rotate_right(2);
99 }
100
101 A0 ^= SIMD_32(RC[16]);
102 NOK_SIMD_THETA(A0, A1, A2, A3, K0, K1, K2, K3);
103
104 SIMD_32::transpose(A0, A1, A2, A3);
105
106 A0.store_be(out);
107 A1.store_be(out + 16);
108 A2.store_be(out + 32);
109 A3.store_be(out + 48);
110
111 in += 64;
112 out += 64;
113 blocks -= 4;
114 }
115
116 if(blocks)
117 Noekeon::encrypt_n(in, out, blocks);
118 }
Botan::load_be
T load_be(const byte in[], size_t off)
Definition: loadstor.h:100
NOK_SIMD_GAMMA
#define NOK_SIMD_GAMMA(A0, A1, A2, A3)
Definition: noekeon_simd.cpp:47
Botan::Noekeon::RC
static const byte RC[17]
Definition: noekeon.h:33
Botan::Noekeon::encrypt_n
void encrypt_n(const byte in[], byte out[], size_t blocks) const
Definition: noekeon.cpp:87
NOK_SIMD_THETA
#define NOK_SIMD_THETA(A0, A1, A2, A3, K0, K1, K2, K3)
Definition: noekeon_simd.cpp:16
Botan::Noekeon::get_EK
const SecureVector< u32bit > & get_EK() const
Definition: noekeon.h:38

## ◆ get_DK()

const SecureVector<u32bit>& Botan::Noekeon::get_DK | ( |  | ) | const
| inlineprotectedinherited

Returns
  const reference to decryption subkeys

Definition at line 43 of file noekeon.h.

Referenced by decrypt_n().

43 { return DK; }

## ◆ get_EK()

const SecureVector<u32bit>& Botan::Noekeon::get_EK | ( |  | ) | const
| inlineprotectedinherited

Returns
  const reference to encryption subkeys

Definition at line 38 of file noekeon.h.

Referenced by encrypt_n().

38 { return EK; }

## ◆ key_spec()

Key_Length_Specification Botan::Block_Cipher_Fixed_Params< BS, KMIN, 0 , 1 >::key_spec | ( |  | ) | const
| inlinevirtualinherited

Returns
  object describing limits on key size

Implements Botan::SymmetricAlgorithm.

Definition at line 110 of file block_cipher.h.

111 {
112 return Key_Length_Specification(KMIN, KMAX, KMOD);
113 }

## ◆ maximum_keylength()

size_t Botan::SymmetricAlgorithm::maximum_keylength | ( |  | ) | const
| inlineinherited

Returns
  minimum allowed key length

Definition at line 33 of file sym_algo.h.

Referenced by Botan::Cascade_Cipher::decrypt_n(), and Botan::ANSI_X931_RNG::randomize().

34 {
35 return key_spec().maximum_keylength();
36 }
Botan::Key_Length_Specification::maximum_keylength
size_t maximum_keylength() const
Definition: key_spec.h:69
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

## ◆ minimum_keylength()

size_t Botan::SymmetricAlgorithm::minimum_keylength | ( |  | ) | const
| inlineinherited

Returns
  maxmium allowed key length

Definition at line 41 of file sym_algo.h.

42 {
43 return key_spec().minimum_keylength();
44 }
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0
Botan::Key_Length_Specification::minimum_keylength
size_t minimum_keylength() const
Definition: key_spec.h:61

## ◆ name()

std::string Botan::Noekeon::name | ( |  | ) | const
| inlinevirtualinherited

Returns
  name of this algorithm

Implements Botan::Algorithm.

Definition at line 25 of file noekeon.h.

25 { return "Noekeon"; }

## ◆ parallel_bytes()

size_t Botan::BlockCipher::parallel_bytes | ( |  | ) | const
| inlineinherited

Returns
  prefererred parallelism of this cipher in bytes

Definition at line 35 of file block_cipher.h.

36 {
37 return parallelism() * block_size() * BOTAN_BLOCK_CIPHER_PAR_MULT;
38 }
Botan::BlockCipher::parallelism
virtual size_t parallelism() const
Definition: block_cipher.h:30
Botan::BlockCipher::block_size
virtual size_t block_size() const =0

## ◆ parallelism()

size_t Botan::Noekeon_SIMD::parallelism | ( |  | ) | const
| inlinevirtual

Returns
  native parallelism of this cipher in blocks

Reimplemented from Botan::BlockCipher.

Definition at line 21 of file noekeon_simd.h.

21 { return 4; }

## ◆ set_key() [1/2]

void Botan::SymmetricAlgorithm::set_key | ( | const SymmetricKey & | key | ) |
| inlineinherited

Set the symmetric key of this object.

Parameters

  key | the SymmetricKey to be set.

Definition at line 60 of file sym_algo.h.

References Botan::OctetString::begin(), and Botan::OctetString::length().

Referenced by Botan::aont_unpackage(), Botan::CTR_BE::clear(), Botan::OFB::clear(), Botan::DESX::decrypt_n(), Botan::Cascade_Cipher::decrypt_n(), Botan::Lion::decrypt_n(), Botan::PKCS5_PBKDF2::derive_key(), Botan::ECB_Decryption::ECB_Decryption(), Botan::ECB_Encryption::ECB_Encryption(), Botan::Lion::encrypt_n(), Botan::HMAC_RNG::HMAC_RNG(), Botan::MAC_Filter::MAC_Filter(), Botan::ANSI_X931_RNG::randomize(), Botan::Randpool::randomize(), Botan::HMAC_RNG::reseed(), Botan::EAX_Base::set_key(), Botan::XTS_Encryption::set_key(), Botan::XTS_Decryption::set_key(), Botan::Record_Writer::set_keys(), Botan::Record_Reader::set_keys(), Botan::StreamCipher_Filter::StreamCipher_Filter(), Botan::DLIES_Decryptor::~DLIES_Decryptor(), and Botan::DLIES_Encryptor::~DLIES_Encryptor().

61 { set_key(key.begin(), key.length()); }
Botan::SymmetricAlgorithm::set_key
void set_key(const SymmetricKey &key)
Definition: sym_algo.h:60

## ◆ set_key() [2/2]

void Botan::SymmetricAlgorithm::set_key | ( | const byte | key[],
|  | size_t | length
| ) |  |
| inlineinherited

Set the symmetric key of this object.

Parameters

  key | the to be set as a byte array.
  length | in bytes of key param

Definition at line 68 of file sym_algo.h.

69 {
70 if(!valid_keylength(length))
71 throw Invalid_Key_Length(name(), length);
72 key_schedule(key, length);
73 }
Botan::SymmetricAlgorithm::valid_keylength
bool valid_keylength(size_t length) const
Definition: sym_algo.h:51
Botan::Algorithm::name
virtual std::string name() const =0

## ◆ valid_keylength()

bool Botan::SymmetricAlgorithm::valid_keylength | ( | size_t | length | ) | const
| inlineinherited

Check whether a given key length is valid for this algorithm.

Parameters

  length | the key length to be checked.

Returns
  true if the key length is valid.

Definition at line 51 of file sym_algo.h.

Referenced by Botan::aont_unpackage(), Botan::HMAC_RNG::HMAC_RNG(), Botan::Lion::Lion(), and Botan::Randpool::Randpool().

52 {
53 return key_spec().valid_keylength(length);
54 }
Botan::Key_Length_Specification::valid_keylength
bool valid_keylength(size_t length) const
Definition: key_spec.h:51
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

## Member Data Documentation

## ◆ RC

const byte Botan::Noekeon::RC
| staticprotectedinherited

Initial value:
= {
0x80, 0x1B, 0x36, 0x6C, 0xD8, 0xAB, 0x4D, 0x9A,
0x2F, 0x5E, 0xBC, 0x63, 0xC6, 0x97, 0x35, 0x6A,
0xD4 }

The Noekeon round constants

Definition at line 33 of file noekeon.h.

Referenced by Botan::Noekeon::decrypt_n(), decrypt_n(), Botan::Noekeon::encrypt_n(), and encrypt_n().

The documentation for this class was generated from the following files:

- src/block/noekeon_simd/noekeon_simd.h
- src/block/noekeon_simd/noekeon_simd.cpp